from stdlib.string cimport Str
from stdlib.socket cimport getaddrinfo, socket, AF_UNSPEC, SOCK_STREAM, AI_PASSIVE, SHUT_RD, SHUT_WR

from libc.stdio cimport puts, printf


def main():
    with nogil:
        a = getaddrinfo(NULL, Str("3490"), AF_UNSPEC, SOCK_STREAM, 0, AI_PASSIVE)[0]

        s = socket(a.family, a.socktype, a.protocol)
        puts('open: ok')

        s.bind(a.sockaddr)
        puts('bind: ok')

        s.listen(5)
        puts('listen: ok')

        while True:
            s1 = s.accept()
            puts('accept: ok')

            r = Str('')
            while True:
                rcv = s1.recv(100)
                if rcv.__len__() > 0:
                    printf('recv: %s\n', Str.to_c_str(rcv))
                    r = r + rcv
                else:
                    puts('connection closed by client')
                    break

            s1.shutdown(SHUT_RD)

            s1.sendall(r)
            puts('send: ok')

            s1.shutdown(SHUT_WR)

            s1.close()
            puts('close 1: ok')

        s.close()
        puts('close 0: ok')

main()
