cdef extern from "<string_view>" namespace "std::string_view" nogil:
    const size_t npos



cdef extern from "<string_view>" namespace "std" nogil:
    cdef cppclass string_view:

        cppclass iterator:
            iterator()
            char& operator*()
            iterator(iterator&)
            iterator operator++()
            iterator operator--()
            bint operator==(iterator)
            bint operator!=(iterator)

        cppclass reverse_iterator:
            char& operator*()
            iterator operator++()
            iterator operator--()
            iterator operator+(size_t)
            iterator operator-(size_t)
            bint operator==(reverse_iterator)
            bint operator!=(reverse_iterator)
            bint operator<(reverse_iterator)
            bint operator>(reverse_iterator)
            bint operator<=(reverse_iterator)
            bint operator>=(reverse_iterator)

        cppclass const_iterator(iterator):
            pass

        cppclass const_reverse_iterator(reverse_iterator):
            pass

        string_view() except +
        string_view(const string_view& s) except +
        string_view(const char* s) except +
        string_view(const char* s, size_t n) except +
        string_view(iterator first, iterator last) except +

        string_view& operator= (const string_view&)

        iterator begin()
        const_iterator const_begin "begin"()
        iterator end()
        const_iterator const_end "end"()
        reverse_iterator rbegin()
        const_reverse_iterator const_rbegin "rbegin"()
        reverse_iterator rend()
        const_reverse_iterator const_rend "rend"()

        char* data()
        size_t size()
        size_t max_size()
        size_t length()
        void swap(string_view& other)
        bint empty()

        char& at(size_t pos) except +
        char& operator[](size_t pos)
        char& front()
        char& back()
        int compare(const string_view& s)
        int compare(size_t pos, size_t len, const string_view& s) except +
        int compare(size_t pos, size_t len, const string_view& s, size_t subpos, size_t sublen) except +
        int compare(const char* s) except +
        int compare(size_t pos, size_t len, const char* s) except +
        int compare(size_t pos, size_t len, const char* s , size_t n) except +

        size_t copy(char* s, size_t len, size_t pos) except +
        size_t copy(char* s, size_t len) except +

        size_t find(const string_view& s, size_t pos)
        size_t find(const string_view& s)
        size_t find(const char* s, size_t pos, size_t n)
        size_t find(const char* s, size_t pos)
        size_t find(const char* s)
        size_t find(char c, size_t pos)
        size_t find(char c)

        size_t rfind(const string_view&, size_t pos)
        size_t rfind(const string_view&)
        size_t rfind(const char* s, size_t pos, size_t n)
        size_t rfind(const char* s, size_t pos)
        size_t rfind(const char* s)
        size_t rfind(char c, size_t pos)
        size_t rfind(char c)

        size_t find_first_of(const string_view&, size_t pos)
        size_t find_first_of(const string_view&)
        size_t find_first_of(const char* s, size_t pos, size_t n)
        size_t find_first_of(const char* s, size_t pos)
        size_t find_first_of(const char* s)
        size_t find_first_of(char c, size_t pos)
        size_t find_first_of(char c)

        size_t find_first_not_of(const string_view& s, size_t pos)
        size_t find_first_not_of(const string_view& s)
        size_t find_first_not_of(const char* s, size_t pos, size_t n)
        size_t find_first_not_of(const char* s, size_t pos)
        size_t find_first_not_of(const char*)
        size_t find_first_not_of(char c, size_t pos)
        size_t find_first_not_of(char c)

        size_t find_last_of(const string_view& s, size_t pos)
        size_t find_last_of(const string_view& s)
        size_t find_last_of(const char* s, size_t pos, size_t n)
        size_t find_last_of(const char* s, size_t pos)
        size_t find_last_of(const char* s)
        size_t find_last_of(char c, size_t pos)
        size_t find_last_of(char c)

        size_t find_last_not_of(const string_view& s, size_t pos)
        size_t find_last_not_of(const string_view& s)
        size_t find_last_not_of(const char* s, size_t pos, size_t n)
        size_t find_last_not_of(const char* s, size_t pos)
        size_t find_last_not_of(const char* s)
        size_t find_last_not_of(char c, size_t pos)
        size_t find_last_not_of(char c)

        string_view substr(size_t pos, size_t len) except +
        string_view substr(size_t pos) except +
        string_view substr()

        bint operator==(const string_view&)
        bint operator==(const char*)

        bint operator!= (const string_view&)
        bint operator!= (const char*)

        bint operator< (const string_view&)
        bint operator< (const char*)

        bint operator> (const string_view&)
        bint operator> (const char*)

        bint operator<= (const string_view&)
        bint operator<= (const char*)

        bint operator>= (const string_view&)
        bint operator>= (const char*)


    cdef cppclass hash_string_view "std::hash<std::string_view>":
        hash_string_view()
        size_t operator() (const string_view&)

